## -------- common makefile -------- ##


## -------- host-specific paths -------- ##
                                         ## MODIFY THESE PATHS PER YOUR INSTALLATION
                                         ## WINDOWS HOST -- SURROUND THESE PATHS WITH SINGLE QUOTES (') IF THEY CONTAIN SPACES  
XDCROOT := 'C:/Program Files/Texas Instruments/xdctools_3_15_04_70'
C6XTOOLS := 'C:/Program Files/Texas Instruments/ccsv4/tools/compiler/c6000'

## -------- remove command -------- ##
                                    ## LINUX HOSTS -- REPLACE $(XDCROOT)/bin/rm WITH rm
RMCMD := $(XDCROOT)/bin/rm

## --------build tools -------- ##
CONFIGURO := $(XDCROOT)/xs xdc.tools.configuro
LOADER := $(XDCROOT)/xs xdc.tools.loader
CC := $(C6XTOOLS)/bin/cl6x -q

## -------- build parameters -------- ##
CONFIG = cfgsite
TARGET = ti.targets.C64P
PLATFORM = ti.platforms.sim64Pxx
PROGNAME = prog

## -------- all-rule -------- ##
all : $(PROGNAME).out

## -------- config-rule -------- ##
$(CONFIG)/linker.cmd $(CONFIG)/compiler.opt : $(PROGNAME).cfg
	$(CONFIGURO) -c $(C6XTOOLS) -t $(TARGET) -p $(PLATFORM) -o $(CONFIG) $(PROGNAME).cfg

## -------- compile-rule -------- ##
$(PROGNAME).obj : $(PROGNAME).c $(CONFIG)/compiler.opt
	$(CC) -@$(CONFIG)/compiler.opt -c $(PROGNAME).c

## -------- link-rule -------- ##
$(PROGNAME).out : $(PROGNAME).obj $(CONFIG)/linker.cmd
	$(CC) -z -c $^ -o $(PROGNAME).out -l $(C6XTOOLS)/lib/rts64plus.lib

## -------- test-rule -------- ##
test : $(PROGNAME).out
	$(LOADER) $(PROGNAME).out

## -------- clean-rule -------- ##
clean :
	$(RMCMD) -rf $(CONFIG) *.obj *.out
